/*****************************************************************************\
 * Vvoj okennho systmu ve WinAPI
 * Bakalsk prce 2006, 
 * Fakulta Informanch Technologi v Brn
 * 
 * HookMenu.cpp
 *
 * HookMenu - implementation of hook procedure on windows with menu
 *
 * Author: Dolej Petr (xdolej06 @ stud.fit.vutbr.cz)
 *         
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#include <windows.h>

extern "C" __declspec(dllexport) BOOL SetHook (HWND hWnd, int IdMsg);
extern "C" __declspec(dllexport) BOOL RemoveHook (BOOL All);

#pragma data_seg("SDILET")
// tyto tri promenne se nastavi volanim funkce SetHook
HWND hWndExace = NULL;
int IdMsgExace = 0;
HHOOK hhGetMsgProc = NULL;
#pragma data_seg()
int counter=0;
#pragma comment(linker, "/section:SDILET,rws")

// tato promenna je viditelna pouze v ramci jedne instance DLL knihovny
static HINSTANCE g_hInst;

LRESULT CALLBACK GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam)
{
  if (nCode < 0) 
	  return CallNextHookEx(hhGetMsgProc, nCode, wParam, lParam);

  LPMSG lpmsg = (LPMSG)lParam;
  switch (lpmsg->message) {
    case WM_COMMAND:
      if (!lpmsg->lParam && hWndExace && IdMsgExace) {
        // zasila specialni zpravu do okna v exaci 
        // wParam ID poloky menu.
        // v Lparam hWnd okna odkud zprava smeruje
        SendMessage(hWndExace,IdMsgExace,lpmsg->wParam,(LPARAM)lpmsg->hwnd);
		break;
      }
  }
  return CallNextHookEx(hhGetMsgProc,nCode,wParam,lParam);
}

BOOL SetHook (HWND hWnd, int IdMsg)
{ 
  counter++;
  if (!hhGetMsgProc)
  {
    hhGetMsgProc = SetWindowsHookEx(WH_GETMESSAGE,(HOOKPROC)GetMsgProc, g_hInst, 0);
    if (hhGetMsgProc) {
      // instalace haku se povedla - prevzit hWnd a IdMsg
      hWndExace = hWnd;
      IdMsgExace = IdMsg;
      return TRUE;
    } else {
      MessageBox(hWnd,
                 "Chyba pri SetWindowsHookEx (WH_GETMESSAGE)",
                 "Chyba",
                 MB_ICONERROR);
    }
  }
  return FALSE;
}

BOOL RemoveHook (BOOL All)
{

 counter--;
 if ((counter==0)||(All))
 {
  if (hhGetMsgProc) 
  {
    if (UnhookWindowsHookEx(hhGetMsgProc)) 
	{
      hhGetMsgProc = NULL;
      return TRUE;
    } 
	else 
	{
      MessageBox(NULL,
                 "Chyba pri UnhookWindowsHookEx (WH_GETMESSAGE)",
                 "Chyba",
                 MB_ICONERROR);
	  counter++;
    }
  }
 }else 
  {
  return TRUE;
  }
  return FALSE;
}


BOOL APIENTRY DllMain (HINSTANCE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved)
{
  g_hInst = hModule;
  return TRUE;
}
