/*****************************************************************************\
 * Vvoj okennho systmu ve WinAPI
 * Bakalsk prce 2006, 
 * Fakulta Informanch Technologi v Brn
 * 
 * SoWinMenu.cpp
 *
 * SoWinMENU - implementation SoWinMENU class
 *
 * Author: Dolej Petr (xdolej06 @ stud.fit.vutbr.cz)
 *         
 * Contributors:
 *
 * ----------------------------------------------------------------------------
 *
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 * This source code is offered for use in the public domain.
 * You may use, modify or distribute it freely.
 *
 * This source code is distributed in the hope that it will be useful but
 * WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
 * DISCLAIMED.  This includes but is not limited to warranties of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * If you find the source code useful, authors will kindly welcome
 * if you give them credit and keep their names with their source code,
 * but do not feel to be forced to do so.
 *
\*****************************************************************************/

#include <stdio.h>
#include <cstdio>
#include <stdlib.h>
#include "SoWinMenu.h"
/*Soubor obsahuje nstroje pro tvorbu a sprvu menu*/

/*global*/
SoIniMenuList SoMenuListInit;
BOOL SOWINMENU_ready=TRUE;

/*---------------Konstruktor------------------------*/
SoWinMENU::SoWinMENU(){
	if (SoMenuListInit.first==NULL){
	   SoMenuListInit.first=NULL;
	   SoMenuListInit.last=NULL;
	   SoMenuListInit.counter=0;}
}
/*-----------------Destruktor-----------------------*/
SoWinMENU::~SoWinMENU(){}

/*----------------Inicializace---------------------*/
void SoWinMENU::Init(HWND Window){ 
  hInstance=GetModuleHandle(NULL);
  hMenu=NULL;
  hWnd=Window;
}

/*-----------------Vytvoen Menu ze souboru pro MDI okno-------------*/
HMENU SoWinMENU::CreateMDIMenufromFile(char *Menu_file,void (*CALL)(int)){

  hMenu = ReadMenuFromFile(Menu_file);

  if(!SetProp(hWnd,"USER_CHILD_MENU",hMenu)){  /*nastaven specilnho menu child okna*/
      MessageBox(NULL,
	  "Error set properities (USER_CHILD_MENU) to child window",
	  "Creation properities Error",
	  MB_OK);
  }
  
  if(!SetProp(hWnd,"USER_MENU_PROCES",CALL)){  /*nastaven voln specilnho menu child okna*/
      MessageBox(NULL,
	  "Error set properities (USER_MENU_PROCES) to child window",
	  "Creation properities Error",
	  MB_OK);
  }
return hMenu;}

/*-----------------Vytvoen Menu z resources pro MDI okno-------------*/
HMENU SoWinMENU::CreateMDIMenu(int ID_MENU,void (*CALL)(int)){

  hMenu = LoadMenu(hInstance, MAKEINTRESOURCE(ID_MENU));

  if(!SetProp(hWnd,"USER_CHILD_MENU",hMenu)){  /*nastaven specilnho menu child okna*/
      MessageBox(NULL,
	  "Error set properities (USER_CHILD_MENU) to child window",
	  "Creation properities Error",
	  MB_OK);
  }
  
  if(!SetProp(hWnd,"USER_MENU_PROCES",CALL)){  /*nastaven voln specilnho menu child okna*/
      MessageBox(NULL,
	  "Error set properities (USER_MENU_PROCES) to child window",
	  "Creation properities Error",
	  MB_OK);
  }
return hMenu;}

/*-----------------Vytvoen Menu ze souboru --------------------------*/
HMENU SoWinMENU::CreateMenufromFile(char *file,void (*CALL)(int)){ /*Vytvori menu ze zadaneho ID resource menu */
																   /*Pri operaci s menu zavola uzivatelovu funkci,ktera je zadana 
																	jako 2. parametr. tato funkce ma povinny parametr typu int
																	ve kterem bde vracena hodnota hodnota ID polozky se ktera byla vybrana*/
SoMenuList * pl;
CALLME=CALL;
hMenu = ReadMenuFromFile(file);
SetMenu(hWnd, hMenu);

if (SoMenuListInit.first==NULL) {
	   pl = (SoMenuList *) malloc(sizeof(SoMenuList));
	   pl->next=NULL;
	   pl->hWnd=hWnd;
	   pl->pMenu=this;
	   SoMenuListInit.first=pl;
	   SoMenuListInit.last=pl;
	   SoMenuListInit.counter++;
	   }
	else {
	   pl = (SoMenuList *) malloc(sizeof(SoMenuList));
	   pl->next=NULL;
	   pl->hWnd=hWnd;
	   pl->pMenu=this;
	   SoMenuListInit.last->next=pl;
	   SoMenuListInit.last=pl;
	   SoMenuListInit.counter++;
	   }

if (!HookMenu()) return NULL; //apply hook

return hMenu;}

/*-----------------Vytvoen Menu z resources -----------------------*/
HMENU SoWinMENU::CreateMenu(int ID_MENU,void (*CALL)(int)){ /*Vytvori menu ze zadaneho ID resource menu */
															/*Pri operaci s menu zavola uzivatelovu funkci,ktera je zadana 
															 jako 2. parametr. tato funkce ma povinny parametr typu int
															 ve kterem bde vracena hodnota hodnota ID polozky se ktera byla vybrana*/
SoMenuList * pl;
CALLME=CALL;
hMenu = LoadMenu(hInstance, MAKEINTRESOURCE(ID_MENU));
SetMenu(hWnd, hMenu);

if (SoMenuListInit.first==NULL) {
	   pl = (SoMenuList *) malloc(sizeof(SoMenuList));
	   pl->next=NULL;
	   pl->hWnd=hWnd;
	   pl->pMenu=this;
	   SoMenuListInit.first=pl;
	   SoMenuListInit.last=pl;
	   SoMenuListInit.counter++;
	   }
	else {
	   pl = (SoMenuList *) malloc(sizeof(SoMenuList));
	   pl->next=NULL;
	   pl->hWnd=hWnd;
	   pl->pMenu=this;
	   SoMenuListInit.last->next=pl;
	   SoMenuListInit.last=pl;
	   SoMenuListInit.counter++;
	   }

if (!HookMenu()) return NULL; //apply hook

return hMenu;}

/*--------------------Spust hookovani--------------------------*/
BOOL SoWinMENU::HookMenu() /*Aplikuj Hookovaci funkci*/
{   DWORD CurrentThreadID=GetCurrentThreadId();
	hMenuHook = ::SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC) CallWndRetProc,hInstance, CurrentThreadID);
	return (hMenuHook != NULL);
}

/*-----------------Vrat handle menu--------------------------*/
HMENU SoWinMENU::GetHMENU()
{
	return hMenu;
}

/*----------------Prohod zaskrtvtko u poloky menu-----------*/
BOOL SoWinMENU::ToggleMenuItemChecked(int ID) /*Toggle State "Checked" Item Vrt TRUE pokud se poloka zakrtla pokud odkrtla FALSE*/
{
MENUITEMINFO mii={0};
 mii.cbSize=sizeof(MENUITEMINFO);
 mii.fMask = MIIM_STATE;
 if (GetMenuItemInfo(hMenu,ID,FALSE,&mii)){
   BOOL checked=mii.fState & MF_CHECKED;
   if (checked)
    {CheckMenuItem(hMenu,ID,MF_UNCHECKED);return FALSE;}
    else {CheckMenuItem(hMenu,ID,MF_CHECKED);return TRUE;}
 }
 return FALSE;
}

/*------------------zrus vsechna menu a jejich hookovani-------------*/
void SoWinMENU::CloseAll(){		
SoMenuList * act;
 while(SoMenuListInit.first!=NULL){
  	 act=SoMenuListInit.first->next;
	
	 if (SoMenuListInit.first!=NULL)
	 {
		 UnhookWindowsHookEx(SoMenuListInit.first->pMenu->hMenuHook);
		 SoMenuListInit.counter--;
	 }
     free(SoMenuListInit.first);
	 SoMenuListInit.first=act;
 }
}

/*--------------------------Zrus menu a jeho hookovani-------------*/
void SoWinMENU::Close(){		/*zrus hookovani*/
SoMenuList * act;
SoMenuList * Last;
Last=SoMenuListInit.first;
act=SoMenuListInit.first;

  while(act!=NULL){
  	
	if (act->pMenu==this)
	  {
	   Last->next=act->next;
	   UnhookWindowsHookEx(act->pMenu->hMenuHook);
	   SoMenuListInit.counter--;
	   if (SoMenuListInit.first==act) SoMenuListInit.first=act->next;
	   free(act);
	   return;
	  }

	Last=act;
	act=act->next;
 }
}


/*--------------------Nvratov funkce pro odchyt zprv menu--------------*/
LRESULT CALLBACK SoWinMENU::CallWndRetProc( int nCode, WPARAM wParam,LPARAM lParam )/*Callback funkce pro hook na menu*/
{ 	  SoMenuList * act;
	  static SoMenuList * last=SoMenuListInit.first;
	  static count=0;
      void (*CallThis)(int);

	  if (count==SoMenuListInit.counter)count=0;
	act=SoMenuListInit.first;
	HWND window = GetForegroundWindow();
	if (act!=NULL)
	while(window!=act->hWnd){
		act=act->next;
		if (act==NULL) break;
	}
	if (act==NULL)
	{return CallNextHookEx(SoMenuListInit.first->pMenu->hMenuHook, nCode, wParam, lParam);}	// nastav dalsi hook}

	if (SOWINMENU_ready==TRUE) {
		SOWINMENU_ready=FALSE;
		if (act!=NULL){
     	if (nCode < 0)
			  return CallNextHookEx(act->pMenu->hMenuHook, nCode, wParam, lParam);     
            if (nCode==HC_ACTION){  // process message 
	          MSG * MenuMsg = (MSG *) lParam;
	          if ((MenuMsg->message==WM_COMMAND)&&(MenuMsg->lParam==0)){
						     count++;
							 if (count==1){
							   CallThis=act->pMenu->CALLME;
			                   CallThis(LOWORD(MenuMsg->wParam));	//volani uzivatelske funkce
							 }
							 
			  }
			}
		}
	SOWINMENU_ready=TRUE;}
  return CallNextHookEx(act->pMenu->hMenuHook, nCode, wParam, lParam);	// nastav dalsi hook
}

/*-----------------Natn menu ze souboru------------------------------*/
HMENU SoWinMENU::ReadMenuFromFile(char *Menu_file){
FILE * fr;
if((fr=fopen(Menu_file, "r"))== NULL) { 
	printf("Error:Cannot open menu file %s",Menu_file);
   return NULL;}

typedef struct S_menu{
                   HMENU kam;
				   int ID;
				   char name[255];
				   }S_menu;

int c,state=0,i=1,p=0,ID_counter=4000,b=0,pm=0;
char buffer[255];
char name[255];
char znak;
S_menu pole_menu[20];
HMENU pole[20];
HMENU hMenuMain;
hMenuMain=NULL;
pole[0]=::CreateMenu();

while ((c=getc(fr))!=EOF) {
	znak=c;
	switch(state){
		
		 case 0: {
				if(c=='B'){buffer[b]=c;b++;state=1;}	//BEGIN
				if(c=='E'){buffer[b]=c;b++;state=1;}	//END
				if(c=='P'){buffer[b]=c;b++;state=1;}	//POPUP
				if(c=='M'){buffer[b]=c;b++;state=1;}	//POPUP
				break;}

		 case 1: {
				if(isalpha(c)){buffer[b]=c;b++;}
				else{
					 buffer[b]='\0';
					 b=0;
					 if (strcmp(buffer,"BEGIN")==0)	  {state=0;}
					 if (strcmp(buffer,"POPUP")==0)	  {state=2;}
					 if (strcmp(buffer,"MENUITEM")==0){state=3;}
					 if (strcmp(buffer,"END")==0)	  {state=7;}
					 
					 if (state==1){state=0;b=0;}
				    }

				  break;}
		 case 2: {	                           /*POPUP*/
				  pole[i] = ::CreateMenu();
				  i++;
				  if (hMenuMain==NULL){hMenuMain=pole[i-1];}
				  state=6;
				 break;}

		 case 3: {
				  if(c=='"'){state=4;}
				  break;}
		 case 4: {
				 if(c=='"'){
							buffer[b]='\0';
							b=0;
							strcpy(name,buffer);
							state=5;}
				 else{
					  buffer[b]=c;b++;
				     }
			      break;}
		 case 5: {
			     if((c!=',')&&(c!='\n')&&(!isspace(c))){buffer[b]=c;b++;}
				 if(c=='\n'){
					 buffer[b]='\0';
					 b=0;
					 if (!AppendMenu(pole[i-1], MF_STRING, atoi(buffer), name))
					 {MessageBox(NULL,
					"There was a problem when reading Menu to window",
					"Application Error",MB_OK);
					 return FALSE;}
					 
					 state=0;
					}
				 break;}
		 case 6: {		//read popup name
				 if(c=='\n'){
						    printf("Error in menu file");	
						    return NULL;}
				 if(c!='"'){buffer[b]=c;b++;}
				 else{
					 buffer[b]='\0';
					 b=0;
					 pole_menu[pm].kam=pole[i-2];
					 pole_menu[pm].ID=(unsigned int) pole[i-1];
					 strcpy(pole_menu[pm].name,buffer);
					 pm++;
					 state=0;
					}
				 	
				 break;}
		case 7: {
			     i--;
				 if (i<0){
						  printf("Error in menu file");	
						  return NULL;}
				 pm--;
				 if (!AppendMenu(pole_menu[pm].kam, MF_POPUP, pole_menu[pm].ID, pole_menu[pm].name))
					 {MessageBox(NULL,
					"There was a problem when reading Menu to window",
					"Application Error",MB_OK);
					 return FALSE;}
				 state=0;
				 break;}
	
	
	
	}//switch

}//while
fclose(fr);
return pole[0];}

